var FancyBoxEnum = 
{
    eWizardDlg   : {ContainerID: 'AWizardHolder'},
    eQuestionDlg : {ContainerID: 'AQuestionHolder'},
    ePasswordDlg : {ContainerID: 'AImagePasswordDlgHolder'}
};
/**********************************************************************************************************************/
var DTCompatibility = function()
{
    this.bIsIE = false;
    this.bOldIE = false;// IE version < 10
    this.strTextTop = '14px';
    this.strTextHeight = '20px';
}
/**********************************************************************************************************************/
DTCompatibility.prototype.Initialize = function()
{
    if ($.browser.msie) 
    {
        this.bIsIE = true;
        if ( parseInt($.browser.version, 10) < 10)
            this.bOldIE = true;
    }
}
/**********************************************************************************************************************/
function AddColElement(elemParent, strValue)
{
    var elemCol = document.createElement('col');
    elemCol.setAttribute('width', strValue); // to be compatible with IE
    elemParent.appendChild(elemCol);
}
/**********************************************************************************************************************/
function AddColGroup(elemParent)
{
    var elemColGroup = document.createElement('colgroup');
    AddColElement(elemColGroup, '25');
    AddColElement(elemColGroup, '215');
    AddColElement(elemColGroup, '420');
    AddColElement(elemColGroup, '165');
    AddColElement(elemColGroup, '16');
    AddColElement(elemColGroup, '16');
    elemParent.appendChild(elemColGroup);
}
/**********************************************************************************************************************/
function NormalizeElementWidth(elem, strValue, nMaxLength)
{
    var nHolderWidth = $(elem).width();
    if (nHolderWidth > nMaxLength)
    {
        elem.style.width = (nMaxLength - 10) + 'px';
        elem.style.overflow = 'hidden';
        elem.title = strValue;
    }
}
/**********************************************************************************************************************/
function AddTDElement(elemParent, strValue)
{
    var elemTD = document.createElement('td');
    elemTD.vAlign = 'top';

    var elemDIV = document.createElement('div');
    elemDIV.innerHTML = strValue;
    elemTD.appendChild(elemDIV);
    elemParent.appendChild(elemTD);

    return elemDIV;
}
/**********************************************************************************************************************/
function CreateConnectionsRecords(elemParent, strConnectionsData)
{
    var elemConnectedClientsList = document.createElement('ul');
    elemConnectedClientsList.className = 'adv-list';

    var nConnectionsCount = 0;
    var nStart = 0;
    do
    {
        var nPos = strConnectionsData.indexOf(";", nStart);
        if (nPos < 0)
            break;

        var strConnectedClient = strConnectionsData.substring(nStart, nPos);
        if (strConnectedClient.length)
        {
            var elemClientItem = document.createElement('li');
            elemClientItem.innerHTML = strConnectedClient;
            elemConnectedClientsList.appendChild(elemClientItem);
            elemParent.className = 'maximizedLi';
            nConnectionsCount++;
        }

        nStart = nPos + 1;
    } while (nStart > 0);

    if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
    {
        var elemDivHolder = document.createElement('div');
        elemDivHolder.style.width = '313px';
        elemDivHolder.style.top = '35px';
        elemDivHolder.style.left = '7px';
        elemDivHolder.style.position = 'absolute';
        elemDivHolder.appendChild(elemConnectedClientsList);
        elemParent.appendChild(elemDivHolder);
        elemParent.style.height = (45 + 25 * nConnectionsCount) + 'px';
    }
    else
        elemParent.appendChild(elemConnectedClientsList);
}
/**********************************************************************************************************************/
function AddTargetElementToList(elemParent, strAlias, strName, strConnections, strConnectedClients, nTargetNo)
{
    var bConnectedClientExist = '' != strConnectedClients;
    if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
    {
        var elemTable = document.createElement('div');
        elemTable.style.width = '892px';
        elemTable.style.height = bConnectedClientExist ? '83px' : '43px';
        elemTable.style.position = 'relative';
        
        var elemDivCB = document.createElement('div');
        elemDivCB.style.width = '30px';
        elemDivCB.style.height = '30px';
        elemDivCB.style.position = 'absolute';

        var elemInput = document.createElement('input');
        elemInput.type = 'checkbox';
        elemInput.style.width = '13px';
        elemInput.style.height = '13px';
        elemInput.style.top = '15px';
        elemInput.style.left = '8px';
        elemInput.style.position = 'absolute';
        elemInput.id = 'cbTargetSelected' + nTargetNo;
        elemDivCB.appendChild(elemInput);

        var elemDivAlias = document.createElement('div');
        elemDivAlias.className = 'ieUnderline';
        elemDivAlias.style.width = '215px';
        elemDivAlias.style.height = CompatibilityObj.strTextHeight;
        elemDivAlias.style.top = CompatibilityObj.strTextTop;
        elemDivAlias.style.left = '35px';
        elemDivAlias.style.position = 'absolute';

        var elemDivAliasHolder = document.createElement('div');
        elemDivAliasHolder.innerHTML = strAlias;
        elemDivAlias.appendChild(elemDivAliasHolder);

        var elemDivName = document.createElement('div');
        elemDivName.className = 'ieUnderline';
        elemDivName.style.width = '415px';
        elemDivName.style.height = CompatibilityObj.strTextHeight;
        elemDivName.style.top = CompatibilityObj.strTextTop;
        elemDivName.style.left = '245px';
        elemDivName.style.position = 'absolute';

        var elemDivNameHolder = document.createElement('div');
        elemDivNameHolder.innerHTML = strName;
        elemDivName.appendChild(elemDivNameHolder);

        var elemDivConnections = document.createElement('div');
        elemDivConnections.className = 'ieUnderline';
        elemDivConnections.style.width = '150px';
        elemDivConnections.style.height = CompatibilityObj.strTextHeight;
        elemDivConnections.style.top = CompatibilityObj.strTextTop;
        elemDivConnections.style.left = '660px';
        elemDivConnections.style.position = 'absolute';
        elemDivConnections.innerHTML = strConnections;

        var elemDivEdit = document.createElement('div');
        elemDivEdit.className = 'icon-td';
        elemDivEdit.style.width = '26px';
        elemDivEdit.style.top = CompatibilityObj.strTextTop;
        elemDivEdit.style.left = '835px';
        elemDivEdit.style.position = 'absolute';

        var elemAEdit = document.createElement('a');
        elemAEdit.className = 'ico edit';
        elemAEdit.title = 'Edit target';
        elemDivEdit.appendChild(elemAEdit);

        var elemDivDelete = document.createElement('div');
        elemDivDelete.className = 'icon-td';
        elemDivDelete.style.width = '26px';
        elemDivDelete.style.top = CompatibilityObj.strTextTop;
        elemDivDelete.style.left = '865px';
        elemDivDelete.style.position = 'absolute';

        var elemADelete = document.createElement('a');
        elemADelete.className = 'ico delete';
        elemADelete.title = 'Remove target';
        elemDivDelete.appendChild(elemADelete);

        elemTable.appendChild(elemDivCB);
        elemTable.appendChild(elemDivAlias);
        elemTable.appendChild(elemDivName);
        elemTable.appendChild(elemDivConnections);
        elemTable.appendChild(elemDivEdit);
        elemTable.appendChild(elemDivDelete);
        elemParent.appendChild(elemTable);

        NormalizeElementWidth(elemDivAliasHolder, strAlias, 214);
        NormalizeElementWidth(elemDivNameHolder, strName, 414);

        if (bConnectedClientExist)
            CreateConnectionsRecords(elemTable, strConnectedClients);

        return;
    }

    var elemTable = document.createElement('table');
    elemParent.appendChild(elemTable);
    
    elemTable.cellSpacing = '0';
    elemTable.cellPadding = '0';
    elemTable.border = '0';
    elemTable.style.width = '100%';
    
    AddColGroup(elemTable);

    var elemTR = document.createElement('tr');
    elemTable.appendChild(elemTR);

    var elemTD1 = document.createElement('td');
    elemTD1.className = 'no-border';
    elemTD1.vAlign = 'top';
    var elemInput = document.createElement('input');
    elemInput.type = 'checkbox';
    elemInput.id = 'cbTargetSelected' + nTargetNo;
    elemTD1.appendChild(elemInput);
    elemTR.appendChild(elemTD1);

    var elemTargetAlias = AddTDElement(elemTR, strAlias);
    var elemTargetName = AddTDElement(elemTR, strName);
    var elemTargetConnections = AddTDElement(elemTR, strConnections);

    var elemTD5 = document.createElement('td');
    elemTD5.className = 'icon-td';
    var elemAEdit = document.createElement('a');
    elemAEdit.className = 'ico edit';
    elemAEdit.title = 'Edit target';
    elemTD5.appendChild(elemAEdit);
    elemTR.appendChild(elemTD5);

    var elemTD6 = document.createElement('td');
    elemTD6.className = 'icon-td';
    var elemADelete = document.createElement('a');
    elemADelete.className = 'ico delete';
    elemADelete.title = 'Remove target';
    elemTD6.appendChild(elemADelete);
    elemTR.appendChild(elemTD6);

    NormalizeElementWidth(elemTargetAlias, strAlias, 215);
    NormalizeElementWidth(elemTargetName, strName, 420);
    NormalizeElementWidth(elemTargetConnections, strConnections, 165);

    if (bConnectedClientExist)
        CreateConnectionsRecords(elemParent, strConnectedClients);
}
/**********************************************************************************************************************/
DTCompatibility.prototype.WizardOpenHelper = function(eBoxName)
{
    for (var eBox in FancyBoxEnum)
        document.getElementById(FancyBoxEnum[eBox].ContainerID).className = (eBoxName.ContainerID == FancyBoxEnum[eBox].ContainerID) ? 'fancybox' : 'tempfancy';
}
/**********************************************************************************************************************/


CompatibilityObj = new DTCompatibility();