var DTWizPhysicalPage = function()
{
    this.strSelectedPhysicalDevice = '';
    this.arrPhysicalDevs = new Array();
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.InitializePage = function()
{
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.UpdateFinishButton = function()
{
    WizardObj.EnableWizardNavButtons(WizardNavButtons.Prev | (this.GetSelectedPhysDevID() == '' ? WizardNavButtons.FinishDisabled : WizardNavButtons.Finish));
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.GetSelectedPhysDevID = function()
{
    return this.strSelectedPhysicalDevice;
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.FillPhysicalDevicesList = function(strTargetsData, selfObj)
{
    var elemMainUL = document.getElementById('physicalDevicesTable');
    while (elemMainUL.firstChild)
        elemMainUL.removeChild(elemMainUL.firstChild);

    delete selfObj.arrPhysicalDevs;
    selfObj.arrPhysicalDevs = eval( '(' + strTargetsData + ')' );
    for (var nDevNo = 0; nDevNo < selfObj.arrPhysicalDevs.length; nDevNo++)
    {
        var elemNewLI = document.createElement('li');
        if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
        {
            var elemTable = document.createElement('div');
            elemTable.style.position = 'relative';
            elemTable.style.width = '530px';
            elemTable.style.height = '60px';
            elemTable.DeviceID = selfObj.arrPhysicalDevs[nDevNo].deviceID;
            elemTable.onclick = function(event) {selfObj.OnDeviceIDClicked(event);};

            var elemDivDeviceLabel = document.createElement('div');
            elemDivDeviceLabel.style.width = '140px';
            elemDivDeviceLabel.style.height = '60px';
            elemDivDeviceLabel.style.position = 'absolute';
            elemDivDeviceLabel.style.wordWrap = 'break-word';
            elemDivDeviceLabel.innerHTML = selfObj.arrPhysicalDevs[nDevNo].deviceLabel;


            var elemDivDeviceID = document.createElement('div');
            elemDivDeviceID.style.left = '150px';
            elemDivDeviceID.style.width = '380px';
            elemDivDeviceID.style.height = '60px';
            elemDivDeviceID.style.position = 'absolute';
            elemDivDeviceID.style.wordWrap = 'break-word';
            elemDivDeviceID.innerHTML = selfObj.arrPhysicalDevs[nDevNo].deviceID;

            elemTable.appendChild(elemDivDeviceLabel);
            elemTable.appendChild(elemDivDeviceID);
        }
        else
        {
            var elemTable = document.createElement('table');
            elemTable.cellSpacing = '0';
            elemTable.cellPadding = '0';
            elemTable.border = '0';
            elemTable.style.width = '530px';
            
            var elemColGroup = document.createElement('colgroup');
            AddColElement(elemColGroup, '35%');
            AddColElement(elemColGroup, '65%');
            elemTable.appendChild(elemColGroup);

            var elemTR = document.createElement('tr');
            elemTR.onclick = function(event) {selfObj.OnDeviceIDClicked(event);};
            elemTable.appendChild(elemTR);
            
            AddTDElement(elemTR, selfObj.arrPhysicalDevs[nDevNo].deviceLabel);

            var elemTD = document.createElement('td');
            var elemDiv = document.createElement('div');
            elemDiv.style.width = '380px';
            elemDiv.innerHTML = selfObj.arrPhysicalDevs[nDevNo].deviceID;
            elemDiv.style.wordWrap = 'break-word';
            elemTD.appendChild(elemDiv);
            elemTR.appendChild(elemTD);
        }
        
        elemNewLI.appendChild(elemTable);
        elemMainUL.appendChild(elemNewLI);
    }
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.OnDeviceIDClicked = function(eventObj)
{
    eventObj = eventObj || window.event;
    var objTDSender = eventObj.target || eventObj.srcElement;
    var strDeviceID = '';
    
    if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
    {
        if (objTDSender.parentNode.nodeName == 'DIV')
            objTDSender = objTDSender.parentNode;

        strDeviceID = objTDSender.DeviceID;
        this.SelectPhysicalDevice(objTDSender);
    }
    else
    {
        //shitty code ('td' or 'td->div' can trigger this click handler)
        var elemParentTR = objTDSender.nodeName == 'DIV' ?  objTDSender.parentNode.parentNode : objTDSender.parentNode;
        strDeviceID = elemParentTR.children[1].children[0].innerHTML;
        this.SelectPhysicalDevice(elemParentTR);
    }

    this.strSelectedPhysicalDevice = strDeviceID;
    WizardObj.EnableWizardNavButtons(WizardNavButtons.Prev | WizardNavButtons.Finish);
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.SelectPhysicalDevice = function(elemParentTR)
{
    var childrenArr = document.getElementById('physicalDevicesTable').children;
    for (var n = 0; n < childrenArr.length; n++)
    {
        if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
        {
            var elemDiv = childrenArr[n].children[0];
            elemDiv.className = elemDiv == elemParentTR ? 'selectedTR' : '';
        }
        else
        {
            var elemTR = childrenArr[n].children[0].children[1];//li->table->tr
            elemTR.className = elemTR == elemParentTR ? 'selectedTR' : '';
        }
    }
}
/**********************************************************************************************************************/
DTWizPhysicalPage.prototype.HandleAction = function(nAction)
{
    if (nAction == ActionEnum.Prev)
    {
        var oldTopHeight = WizardObj.GetFancyBoxTopAndHeight();
        WizardObj.ShowPageByName(WizPagesEnum.eTargetGenProps);
        WizardObj.AdjustWizardWindow(oldTopHeight.height, oldTopHeight.top);
        WizardObj.EnableWizardNavButtons(WizardNavButtons.Prev | WizardNavButtons.Next);
    }
    else if (nAction == ActionEnum.Finish)
    {
        $.fancybox.close();
        WizardObj.ProceedFinishOperation();
    }
}
/**********************************************************************************************************************/

WizPhysPageObj = new DTWizPhysicalPage();