var DTHttpServPage = function()
{
    this.arrData = new Array();
    this.bISCSIAdapterStarted = true;
    this.nTotalConnections = 0;
}
/**********************************************************************************************************************/
function OnDocumentReady()
{
    CompatibilityObj.Initialize();
    $('.fancybox').fancybox();
    MainPageObj.UpdateiSCSIAdapterStatus();
    MainPageObj.UpdateTargetsList();
    WizardObj.InitializeWizard();
    VirtualFileSelCtrlObj.InitializeCtrl('DirControlHolderVirtual');
    VirtualFileSelCtrlObj.SetSize(552, 287);//magic numbers => should be calculated
    WizVirtPageObj.InitializeExtensionsFilterCB();

    VHDFileSelCtrlObj.InitializeCtrl('DirControlHolderVHD');
    VHDFileSelCtrlObj.SetSize(552, 287);//magic numbers => should be calculated
    WizVHDPageObj.InitializeExtensionsFilterCB();
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.UpdateTargetsList = function()
{
    sendAjaxRequest('ajax_get_targets', this.LoadTargets, this);
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.LoadTargets = function(strTargetsData, selfObj)
{
    var elemMainUL = document.getElementById('TargetsTable');
    while (elemMainUL.firstChild)
        elemMainUL.removeChild(elemMainUL.firstChild);

    selfObj.nTotalConnections = 0;
    delete selfObj.arrData;
    selfObj.arrData = eval( "(" + strTargetsData + ")" );
    var nTargetsCount = selfObj.arrData.length;
    for (var i = 0; i < nTargetsCount; i++)
    {
        var elemNewLI = document.createElement('li');
        elemMainUL.appendChild(elemNewLI);
        elemNewLI.setAttribute('Searchable', true);
        elemNewLI.setAttribute('CheckboxID', 'cbTargetSelected' + i);
        elemNewLI.setAttribute('TargetName', selfObj.arrData[i].targetName);
        elemNewLI.onclick = function(event) {selfObj.onClickDispatcher(event);};

        selfObj.nTotalConnections += parseInt(selfObj.arrData[i].maxConnections, 10);

        AddTargetElementToList(elemNewLI, selfObj.arrData[i].targetAlias, selfObj.arrData[i].targetName, selfObj.arrData[i].connections + '/' + selfObj.arrData[i].maxConnections, selfObj.arrData[i].connectedClients, i);
    }

    var elemCBSelAll = document.getElementById('cbSelectAll');
    elemCBSelAll.disabled = !nTargetsCount;
    if (!nTargetsCount)
        elemCBSelAll.checked = false;

    selfObj.updateSelectAllCBStatus();
}
/**********************************************************************************************************************/
function OnEditTargetClick(strTargetName)
{
    WizardObj.OpenEditWizard(strTargetName);
}
/**********************************************************************************************************************/
function TargetRemoveResultHandler(strResult, selfObj)
{
    if (strResult != 'OK')
        alert(strResult);

    selfObj.UpdateTargetsList();
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.ProceedTargetDelete = function(strTargetName)
{
    sendAjaxRequest('ajax_remove_target?targetNames=' + strTargetName, TargetRemoveResultHandler, this);
}
/**********************************************************************************************************************/
function onEnableRemoveButton(bEnable)
{
    document.getElementById('RemoveButton').className = bEnable ? 'button red' : 'button disabled';
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.RequestTargetRemove = function(strTargetName)
{
    var selfObj = this;
    QuestionCtrlObj.SetQuestionTitleText('Remove target', 'Do you really want to remove target <br>"' + strTargetName + '"?', 'Remove');
    QuestionCtrlObj.OpenQuestion(function(){selfObj.ProceedTargetDelete(strTargetName + ';');});
}
/**********************************************************************************************************************/
function GetParentElement(elemChild, strParentNodeType)
{
    var elemTemp = elemChild;
    while (elemTemp)
    {
        if (elemTemp.nodeName == strParentNodeType && elemTemp.getAttribute('Searchable'))
            break;

        elemTemp = elemTemp.parentNode;
    }
    
    return elemTemp;
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.onClickDispatcher = function(event)
{
    var eventObjNew = event || window.event;
    if (eventObjNew && eventObjNew.stopPropagation)
        eventObjNew.stopPropagation();

    var objSender = eventObjNew.target || eventObjNew.toElement || eventObjNew.srcElement;
    var elemParentLI = GetParentElement(objSender, 'LI');
    if (!elemParentLI)
        return;

    var strTargetName = elemParentLI.getAttribute('TargetName');
    var strCbID = elemParentLI.getAttribute('CheckboxID');

    var objSenderNodeName = objSender.nodeName;
    if (objSenderNodeName == 'A')
    {
        if (objSender.className == 'ico delete')
            this.RequestTargetRemove(strTargetName);
        else if (objSender.className == 'ico edit')
            OnEditTargetClick(strTargetName);

        return;
    }
    else if (objSenderNodeName != 'INPUT')
    {
        var elemCB = document.getElementById(strCbID);
        elemCB.checked = !elemCB.checked;
    }

    this.updateSelectAllCBStatus();
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.onCBSelAllClick = function()
{
    var bSelAllChecked  = document.getElementById('cbSelectAll').checked;
    for (var nTarget = 0; nTarget < this.arrData.length; nTarget++)
    {
        var cbElement = document.getElementById('cbTargetSelected' + nTarget);
        if (cbElement)
            cbElement.checked = bSelAllChecked;
    }
    onEnableRemoveButton(bSelAllChecked);
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.updateSelectAllCBStatus = function()
{
    var nTargetsCount = this.arrData.length;
    var bAllSelected = nTargetsCount;
    var bAtLeastOneSelected = false;
    for (var nTarget = 0; nTarget < nTargetsCount; nTarget++)
    {
        var cbElement = document.getElementById('cbTargetSelected' + nTarget);
        if (cbElement)
        {
            if (!cbElement.checked)
                bAllSelected = false;
            else
                bAtLeastOneSelected = true;
        }
    }
    
    document.getElementById('cbSelectAll').checked = bAllSelected;
    onEnableRemoveButton(bAtLeastOneSelected);
}
/**********************************************************************************************************************/
function HandleAdapterSwitchResult(strResult)
{
    if (strResult != 'OK')
        alert(strResult);
    else
        UpdateSwitchISCSIAdapterButton();
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.ProceedSwitchAdapter = function()
{
    sendAjaxRequest('ajax_iscsiadapter_control?SetiSCSIEnabled=' + (this.bISCSIAdapterStarted ? 'FALSE' : 'TRUE'), HandleAdapterSwitchResult);
    this.bISCSIAdapterStarted = !this.bISCSIAdapterStarted;
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.OnStopServiceBtnClick = function()
{
    if (!this.bISCSIAdapterStarted)
    {
        this.ProceedSwitchAdapter();
        return;
    }

    var selfObj = this;
    QuestionCtrlObj.SetQuestionTitleText('Stop iSCSI Adapter', 'Do you really want to stop Stop iSCSI Adapter?', 'Stop');
    QuestionCtrlObj.OpenQuestion(function(){selfObj.ProceedSwitchAdapter();});
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.OnRemoveTargetsBtnClick = function()
{
    if (document.getElementById('RemoveButton').className == 'button disabled')
        return;

    var strSelected = '';
    for (var nTarget = 0; nTarget < this.arrData.length; nTarget++)
        if (document.getElementById('cbTargetSelected' + nTarget).checked)
            strSelected += this.arrData[nTarget].targetName + ';';
    
    var selfObj = this;
    QuestionCtrlObj.SetQuestionTitleText('Remove selected target(s)', 'Do you really want to remove selected target(s)?', 'Remove');
    QuestionCtrlObj.OpenQuestion(function(){selfObj.ProceedTargetDelete(strSelected);});
}
/**********************************************************************************************************************/
function RemoveGUIDFromTargetName(strTargetName)
{
	const GUIDLength = 8;
	
	var pntIdx = strTargetName.length - GUIDLength - 1;
	
	if (pntIdx < 0 || strTargetName[pntIdx] != '.')
	{
		return strTargetName;
	}
	
	return strTargetName.substr(0, pntIdx);
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.CheckTargetNameAvailability = function(strTargetName)
{
	var targetNameWithoutGUID = RemoveGUIDFromTargetName(strTargetName);
	
    for (var nTarget = 0; nTarget < this.arrData.length; nTarget++)
	{
		var arrTargetNameWithoutGUID = RemoveGUIDFromTargetName(this.arrData[nTarget].targetName);
	
		// We don't know any targetName has or not GUID postfix
		// that's why we check all cases
        if (arrTargetNameWithoutGUID == targetNameWithoutGUID ||
			this.arrData[nTarget].targetName == strTargetName ||
			arrTargetNameWithoutGUID == strTargetName ||
			this.arrData[nTarget].targetName == targetNameWithoutGUID)
            return false;
	}

    return true;
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.CheckTargetAliasAvailability = function(strTargetAlias)
{
    for (var nTarget = 0; nTarget < this.arrData.length; nTarget++)
	{
        if (this.arrData[nTarget].targetAlias == strTargetAlias)
            return false;
	}

    return true;
}
/**********************************************************************************************************************/
DTHttpServPage.prototype.UpdateiSCSIAdapterStatus = function()
{
    sendAjaxRequest('ajax_iscsiadapter_control?query_status', ProceedUpdateiSCSIAdapterStatus);
}
/**********************************************************************************************************************/
function UpdateSwitchISCSIAdapterButton()
{
    document.getElementById('SwitchAdapterButton').innerHTML = MainPageObj.bISCSIAdapterStarted ? 'Stop iSCSI Adapter' : 'Start iSCSI Adapter';
}
/**********************************************************************************************************************/
function ProceedUpdateiSCSIAdapterStatus(strResult)
{
    MainPageObj.bISCSIAdapterStarted = 'Enabled' == strResult;
    UpdateSwitchISCSIAdapterButton();
}
/**********************************************************************************************************************/
function sendAjaxRequest(url, handlerFunc, objContext, elemParent)
{
    var reqObj = null;
    if (window.XMLHttpRequest) 
    {               
        try 
        {
            reqObj = new XMLHttpRequest();
        }
        catch (e){}
    } 
    else if (window.ActiveXObject) 
    {
        try
        {
            reqObj = new ActiveXObject('Msxml2.XMLHTTP');
        }
        catch (e)
        {
            try 
            {
                reqObj = new ActiveXObject('Microsoft.XMLHTTP');
            }
            catch (e){}
        }
    }
 
    if (reqObj) 
    {       
        reqObj.open("POST", url, true);
        reqObj.onreadystatechange = function() 
        {
            if (reqObj.readyState == 4 && reqObj.status == 200)
                handlerFunc(reqObj.responseText, objContext, elemParent);
        };
        reqObj.send(null);
    }
}
/**********************************************************************************************************************/

MainPageObj = new DTHttpServPage();